<?php
namespace Claromentis\Projects\Controller;

$GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"] ?: array()) + array("_1f50e30be8c2fefa6881834e" . "71d504a2" => base64_decode("b2Zmc" . "2V0"), "_1bee3d4d1" . "d0df49e0fc" . "f8b9ed2ecb" . "8fa" => base64_decode("ZXh" . "wbG" . "9kZ" . "Q=="), "_f6a16426f3b3f03" . "ad6bacec912eec29" . "1" => base64_decode("c29yd" . "A=="), "_18c93a32b" . "a5faf95093" . "89a94787e6" . "798" => base64_decode("bW9kaWZp" . "ZWQ="), "_8ab6ddf42088608c" . "501fcded8995e76c" => base64_decode("IA=" . "="), "_f11369824f533e8206f9ccc0" . "c9aab3a0" => base64_decode("bGlta" . "XQ="), "_7af8fa154" . "3a4f2c3d3e" . "6350f7f0c4" . "fcd" => base64_decode("Y" . "X" . "N" . "j"), "_4d707fab93" . "bebb00bbe69" . "e8159697c90" => base64_decode(""), "_0290d5279a73376ebff811c191d735" . "a6" => base64_decode("c29ydF9k" . "aXI="), "_a71dc9333bd8ad" . "95d55d6624b4778" . "75f" => base64_decode("ZGF0YQ=" . "="), "_25867e3" . "e3db2896" . "9253f3a3" . "70c3166b" . "a" => base64_decode("ZG" . "Vz" . "Yw" . "=="), "_ea8229a121285ee649a72f" . "d880bac39b" => base64_decode("YXJyYXlfZmlsd" . "GVy"), "_b1767a84b84eaf" . "3919b918bd13dd4" . "fdd" => base64_decode("dG9waWNfcGlu" . "bmVk"), "_206f063cdbd5801a28370" . "4ef0c883699" => base64_decode("a2V" . "5d2" . "9yZ" . "HM="), "_f4eafa5f493306ff" . "db51a688b21dd507" => base64_decode("dG90YWw" . "="));
use Claromentis\Core\Http\JsonPrettyResponse;
use Claromentis\Core\Http\RequestData;
use Claromentis\Core\Http\StatusCode;
use Claromentis\Core\REST\RestFormatter;
use Claromentis\Core\Security\Exception\AccessDeniedException;
use Claromentis\Core\Security\SecurityContext;
use Claromentis\Projects\Api\TopicApi;
use Claromentis\Projects\Dialog\TopicDialog;
use Claromentis\Projects\Entity\Topic;
use Claromentis\Projects\PermissionsChecker;
use Claromentis\Projects\Repository\ProjectRepository;
use Psr\Http\Message\ServerRequestInterface;
use Symfony\Component\HttpKernel\Exception\NotFoundHttpException;




class TopicRestController
{
    
    
    
    
    protected $project_provider;
    
    
    
    
    protected $topic_api;
    
    
    
    
    protected $format;
    
    
    
    
    protected $dialog;
    public function __construct(ProjectRepository $project_repository, TopicApi $topic_api, RestFormatter $format, TopicDialog $dialog)
    {
        $this->project_provider = $project_repository;
        $this->topic_api = $topic_api;
        $this->format = $format;
        $this->dialog = $dialog;
    }
    public function ShowList(PermissionsChecker $permissions_checker, RequestData $request_data, int $project_id)
    {
        $project = $this->project_provider->GetProject($project_id);
        if ($project === null) {
            throw new NotFoundHttpException();
        }
        if (!$project->CanIViewAllTopics($permissions_checker)) {
            throw new AccessDeniedException();
        }
        $_f6a16426f3b3f03ad6bacec912eec291 = $request_data->Get($GLOBALS["__65da1b1ec2d6653e8a0ab784" . "8e536215"]["_f6a16426f3b3" . "f03ad6bacec91" . "2eec291"], $GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"]["_18c93a32ba5faf95" . "09389a94787e6798"]);
        $_0290d5279a73376ebff811c191d735a6 = $request_data->Get($GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_0290d5279a73376ebff811c" . "191d735a6"], $_f6a16426f3b3f03ad6bacec912eec291 === $GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_18c93a32ba5faf9" . "509389a94787e679" . "8"] ? $GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_25867e3e3db28969253f" . "3a370c3166ba"] : $GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"]["_7af8fa1543a4" . "f2c3d3e6350f7" . "f0c4fcd"]);
        $_206f063cdbd5801a283704ef0c883699 = $this->GetKeywords($request_data);
        $_e14537bb3cca32e664b153d5ceb1ef47 = $this->topic_api->GetTopics($project_id, $_f6a16426f3b3f03ad6bacec912eec291, $_0290d5279a73376ebff811c191d735a6, $request_data->Get($GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_f11369824f533e8206f9ccc0c9aab3a" . "0"], 20), $request_data->Get($GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"]["_1f50e30be8c" . "2fefa6881834" . "e71d504a2"], 0), $_206f063cdbd5801a283704ef0c883699);
        $_f4eafa5f493306ffdb51a688b21dd507 = $this->topic_api->CountTopics($project_id, $_206f063cdbd5801a283704ef0c883699);
        $_cfcf180dac4148ce727d28c28880806e = [];
        foreach ($_e14537bb3cca32e664b153d5ceb1ef47 as $topic) {
            $_cfcf180dac4148ce727d28c28880806e[] = $this->dialog->ShowJson($topic);
        }
        return new JsonPrettyResponse([$GLOBALS["__65da1b1ec2d665" . "3e8a0ab7848e5362" . "15"]["_a71dc9333bd8ad95d55d6624" . "b477875f"] => $_cfcf180dac4148ce727d28c28880806e, $GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"]["_f4eafa5f49330" . "6ffdb51a688b21" . "dd507"] => $_f4eafa5f493306ffdb51a688b21dd507]);
    }
    public function Show(PermissionsChecker $permissions_checker, Topic $topic, int $project_id)
    {
        $project = $this->project_provider->GetProject($topic->project_id);
        if ($topic->project_id !== $project_id) {
            throw new NotFoundHttpException();
        }
        if (!$project->CanIViewTopic($permissions_checker, $topic)) {
            throw new AccessDeniedException();
        }
        return new JsonPrettyResponse($this->dialog->ShowJson($topic));
    }
    public function Update(PermissionsChecker $permissions_checker, int $project_id, Topic $topic, SecurityContext $context, ServerRequestInterface $_b791059c94b285cdf1c90ca6f3a8f2a6)
    {
        $_231341bedbbeea0ba9fa8da63ef63dc1 = !$topic->id;
        $project = $this->project_provider->GetProject($project_id);
        if ($topic->project_id && $topic->project_id !== $project_id) {
            throw new NotFoundHttpException();
        }
        if (!$project->CanIEditTopic($permissions_checker, $topic)) {
            throw new AccessDeniedException();
        }
        $_ed5f03d686c37933b5943f295c6b4a43 = $this->format->GetJson($_b791059c94b285cdf1c90ca6f3a8f2a6);
        $_0918e1b00a3c23a7eb313ecb5b7471a1 = $this->dialog->TopicDataFromJson($_ed5f03d686c37933b5943f295c6b4a43, $context, $project_id);
        if (isset($_0918e1b00a3c23a7eb313ecb5b7471a1[$GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_b1767a84b84eaf3919b918bd13dd" . "4fdd"]]) && !$project->CanIPinTopic($permissions_checker, $topic)) {
            throw new AccessDeniedException();
        }
        $this->topic_api->Update($topic, $_0918e1b00a3c23a7eb313ecb5b7471a1);
        return new JsonPrettyResponse($this->dialog->ShowJson($topic), $_231341bedbbeea0ba9fa8da63ef63dc1 ? StatusCode::CREATED : StatusCode::OK);
    }
    public function Delete(PermissionsChecker $permissions_checker, int $project_id, Topic $topic)
    {
        $project = $this->project_provider->GetProject($project_id);
        if ($topic->project_id && $topic->project_id !== $project_id) {
            throw new NotFoundHttpException();
        }
        if (!$project->CanIEditTopic($permissions_checker, $topic)) {
            throw new AccessDeniedException();
        }
        $this->topic_api->Delete($topic);
        return new JsonPrettyResponse($this->dialog->ShowJson($topic));
    }
    protected function GetKeywords(RequestData $request_data)
    {
        $_028f0444215be3fb127b022ccc085771 = $request_data->Get($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"]["_206f063cdbd5801a2837" . "04ef0c883699"], $GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_4d707fab93bebb00b" . "be69e8159697c90"]);
        if (empty($_028f0444215be3fb127b022ccc085771)) {
            return [];
        }
        return $GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_ea8229a121285ee649a72fd880b" . "ac39b"]($GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"]["_1bee3d4d1d0" . "df49e0fcf8b9" . "ed2ecb8fa"]($GLOBALS["__65da1b1ec2d6653e8a0ab784" . "8e536215"]["_8ab6ddf420886" . "08c501fcded899" . "5e76c"], $_028f0444215be3fb127b022ccc085771));
    }
}